// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use crate::InetAddress;
use crate::InetSocketAddress;
use crate::SocketAddress;
use crate::SocketConnectable;
use glib::object::Cast;
use glib::object::IsA;
use glib::translate::*;
use std::fmt;

glib::wrapper! {
    pub struct ProxyAddress(Object<ffi::GProxyAddress, ffi::GProxyAddressClass>) @extends InetSocketAddress, SocketAddress, @implements SocketConnectable;

    match fn {
        get_type => || ffi::g_proxy_address_get_type(),
    }
}

impl ProxyAddress {
    pub fn new<P: IsA<InetAddress>>(
        inetaddr: &P,
        port: u16,
        protocol: &str,
        dest_hostname: &str,
        dest_port: u16,
        username: Option<&str>,
        password: Option<&str>,
    ) -> ProxyAddress {
        unsafe {
            SocketAddress::from_glib_full(ffi::g_proxy_address_new(
                inetaddr.as_ref().to_glib_none().0,
                port,
                protocol.to_glib_none().0,
                dest_hostname.to_glib_none().0,
                dest_port,
                username.to_glib_none().0,
                password.to_glib_none().0,
            ))
            .unsafe_cast()
        }
    }
}

unsafe impl Send for ProxyAddress {}
unsafe impl Sync for ProxyAddress {}

pub const NONE_PROXY_ADDRESS: Option<&ProxyAddress> = None;

pub trait ProxyAddressExt: 'static {
    fn get_destination_hostname(&self) -> glib::GString;

    fn get_destination_port(&self) -> u16;

    fn get_destination_protocol(&self) -> Option<glib::GString>;

    fn get_password(&self) -> Option<glib::GString>;

    fn get_protocol(&self) -> glib::GString;

    fn get_uri(&self) -> Option<glib::GString>;

    fn get_username(&self) -> Option<glib::GString>;
}

impl<O: IsA<ProxyAddress>> ProxyAddressExt for O {
    fn get_destination_hostname(&self) -> glib::GString {
        unsafe {
            from_glib_none(ffi::g_proxy_address_get_destination_hostname(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn get_destination_port(&self) -> u16 {
        unsafe { ffi::g_proxy_address_get_destination_port(self.as_ref().to_glib_none().0) }
    }

    fn get_destination_protocol(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::g_proxy_address_get_destination_protocol(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn get_password(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::g_proxy_address_get_password(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn get_protocol(&self) -> glib::GString {
        unsafe {
            from_glib_none(ffi::g_proxy_address_get_protocol(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn get_uri(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::g_proxy_address_get_uri(self.as_ref().to_glib_none().0)) }
    }

    fn get_username(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::g_proxy_address_get_username(
                self.as_ref().to_glib_none().0,
            ))
        }
    }
}

impl fmt::Display for ProxyAddress {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ProxyAddress")
    }
}
